module seg7(CLK6, d3, d2, d1, d0, SG, SA);
	input CLK6;
	input [3:0] d3, d2, d1, d0;
	output [7:0] SG;
	output [3:0] SA;
	reg [3:0] d;
	reg [15:0] cnt;
	reg [1:0] st;
	reg [7:0] SG;
	reg [3:0] SA;

	always @(d) begin
		case (d)
			4'b0000 : SG <= 8'b00111111;
			4'b0001 : SG <= 8'b00000110;
			4'b0010 : SG <= 8'b01011011;
			4'b0011 : SG <= 8'b01001111;
			4'b0100 : SG <= 8'b01100110;
			4'b0101 : SG <= 8'b01101101;
			4'b0110 : SG <= 8'b01111101;
			4'b0111 : SG <= 8'b00100111;
			4'b1000 : SG <= 8'b01111111;
			4'b1001 : SG <= 8'b01101111;
			4'b1010 : SG <= 8'b01110111;
			4'b1011 : SG <= 8'b01111100;
			4'b1100 : SG <= 8'b00111001;
			4'b1101 : SG <= 8'b01011110;
			4'b1110 : SG <= 8'b01111001;
			4'b1111 : SG <= 8'b01110001;
		endcase
	end
	
	always @(posedge CLK6) begin
		if (cnt == 16'd5999) begin
			cnt <= 0;
			st <= st + 2'd1;
			case (st)
				2'b00 : begin d <= d0; SA <= 4'b0001; end
				2'b01 : begin d <= d1; SA <= 4'b0010; end
				2'b10 : begin d <= d2; SA <= 4'b0100; end
				2'b11 : begin d <= d3; SA <= 4'b1000; end
			endcase
		end
		else cnt <= cnt + 16'd1;
	end
endmodule

module sw_clk(CLK6, a, q);
	input CLK6, a;
	output q;
	reg q, st;
	reg [23:0] cnt;
	always @(posedge CLK6) begin
		if (a == 1'b1 && q == 1'b0 && st == 1'b0) begin
			q <= 1'b1;
		end
		else if (q == 1'b1) begin
			if (cnt == 899999) begin
				cnt <= 24'd0;
				q <= 1'b0;
				st <= 1'b1;
			end
			else cnt <= cnt + 24'd1;
		end
		if (st == 1'b1 && a == 1'b0) st <= 1'b0;
	end
endmodule
