module sample(CLK6, LED, SW, SG, SA);
	input CLK6;
	input [3:0] SW;
	output [7:0] LED, SG;
	output [3:0] SA;
	reg [3:0] r0, r1, pc, daddr, d2io;
	wire [3:0] iaddr, d2cpu, op, imm;
	wire [7:0] idata;
	wire [3:0] d3, d2, d1, d0;
	reg mem_wr, st, z;
	wire clk, rst;
	
	imem i0(iaddr, idata);
	dmem i1(clk, mem_wr, daddr, d2io, d2cpu);
	sw_clk iclk(CLK6, ~SW[0], clk);
	seg7 iseg7(CLK6, d3, d2, d1, d0, SG, SA);

	assign LED = {z, st, clk, 1'b0, op};
	assign d0 = r0, d1 = r1, d2 = iaddr, d3 = daddr;
	assign rst = ~SW[3];
	assign iaddr = pc;
	assign op = idata[7:4], imm = idata[3:0];
	always @(posedge clk or posedge rst) begin
		if (rst == 1'b1) begin
			pc <= 4'h0; st <= 1'b0; z <= 1'b0; mem_wr <= 1'b0; daddr <= 4'h0; r0 <= 4'h0; r1 <= 4'h0;
		end
		else begin
			if (st == 0) begin
				st <= 1'b1;
				mem_wr <= 1'b0;
				case (op)
					// operation
					// resister access, mem_wr setf for op=1000/1001
					....
				endcase

			end
			else begin
				st <= 1'b0;
				// memory read for op=1010/1011
				case (op)
					...
				endcase

   				// update pc
				if (op == 4'b0110) ...
			end
		end
	end
endmodule
